Imports System.Windows.Forms
''' <summary>Logovac tda - logovn do <see cref="ListBox">ListBoxu</see></summary>
Public Class clog
    ''' <summary><see  cref="ListBox"/>, do kterho se loguje</summary>
    Private mlog As ListBox
    ''' <summary>Posledn zprva</summary>
    Private lastmsg As String
    ''' <summary>Obsahuje hodnotu vlastnosti <see cref="Format"/></summary>
    Private _Format As String = "{1}"
    ''' <summary>CTor</summary>
    ''' <param name="ListBox"><see cref="ListBox"/> do kterho se m logovat</param>
    ''' <exception cref="ArgumentNullException"><paramref name="ListBox"/> je null</exception>
    Public Sub New(ByVal ListBox As ListBox)
        If ListBox Is Nothing Then Throw New ArgumentNullException("ListBox")
        Me.mlog = ListBox
    End Sub
    ''' <summary>Pidat zprvu</summary>
    ''' <param name="line_text">Text zprvy</param>
    Public Sub add(ByVal line_text As String)
        If mlog.InvokeRequired Then
            mlog.Invoke(New Action(Of String)(AddressOf add), line_text)
            Exit Sub
        End If
        lastmsg = String.Format(Format, Now(), line_text)
        mlog.Items.Add(lastmsg)
        mlog.SelectedIndex = mlog.Items.Count - 1
        mlog.Refresh()
    End Sub
    ''' <summary>Pidat zprvu s formtovnm</summary>
    ''' <param name="line_text">Text zprvy s formtovnm</param>
    ''' <param name="obj">Poloky pro vloen do textu</param>
    Public Sub add(ByVal line_text As String, ByVal ParamArray obj As Object())
        add(String.Format(line_text, obj))
    End Sub
    ''' <summary>Text posledn zprvy</summary>
    ReadOnly Property lastMsgText() As String
        Get
            Return lastmsg
        End Get
    End Property
    ''' <summary>Formtovac eezec pouit na zprvu</summary>
    ''' <remarks>{0} zastupuje aktuln datum, {1} text zprvy</remarks>
    ''' <exception cref="System.ArgumentNullException">format being set is null.</exception>
    ''' <exception cref="System.FormatException">format bein set is invalid.-or- The number indicating an argument to format is less than zero, or greater than or equal to the number of specified objects to format (2).</exception>
    Public Property Format$()
        Get
            Return _Format
        End Get
        Set(ByVal value$)
            String.Format(value, Now, "test")
            _Format = value
        End Set
    End Property
End Class
