''' <summary>Nstroje pro prci s daty</summary>
Public Module DateTools
    ''' <summary>Pite ke dneku zadan poet dn a pokud to vde na vkend pesune to na pondl</summary>
    ''' <param name="Days">Poet dn k piten</param>
    Public Function DaysFromNow(ByVal Days As UInteger) As Date
        Return DaysFrom(Now, Days)
    End Function
    ''' <summary>Pite k zadanmu datu zadan poet dn a pokud to vde na vkend pesune to na pondl</summary>
    ''' <param name="Day">Poten datum</param>
    ''' <param name="Days">Poet dn k piten</param>
    Public Function DaysFrom(ByVal Day As Date, ByVal Days As UInteger) As Date
        Return Weekend2Monday(Day.AddDays(Days))
    End Function
    ''' <summary>Pokdu se zadan datum nachz o vkendu vrt datum nejbliho nsledujcho pondlku</summary>
    ''' <param name="Day">Datum ke kontrole</param>
    ''' <returns>Datum nejbliho nsledujcho pracovnho dne po <paramref name="Day"/> vetn</returns>
    Public Function Weekend2Monday(ByVal Day As Date) As Date
        Select Case Day.DayOfWeek
            Case DayOfWeek.Saturday
                Return Day.AddDays(2)
            Case DayOfWeek.Monday
                Return Day.AddDays(1)
            Case Else
                Return Day
        End Select
    End Function
    ''' <summary>Vrt nejbli nsledujci den v msci od zadanho data s urenm slem dne v msci a mimo vkend</summary>
    ''' <param name="Date">Datum od nho hledat</param>
    ''' <param name="Day">slo dne v msci, kter vrtit</param>
    ''' <returns>Pokud je <paramref name="Day"/> 29, 30 nebo 31 a msc nem poadovan poet dn vrt den v nsledujcm msci</returns>
    ''' <exception cref="ArgumentException"><paramref name="Day"/> je 0 nebo vc jak 31</exception>
    Public Function DayInMonth(ByVal [Date] As Date, ByVal Day As Byte) As Date
        If Day = 0 OrElse Day > 31 Then Throw New ArgumentOutOfRangeException("Day", "Day mus bt od 1 do 31")
        Dim First As Date
        If [Date].Day >= Day Then
            First = New Date([Date].Year, [Date].Month + 1, 1)
        Else
            First = New Date([Date].Year, [Date].Month, 1)
        End If
        Return Weekend2Monday(First.AddDays(Day - 1))
    End Function
    ''' <summary>Vrt nejbli nsledujci den v msci od te s urenm slem dne v msci a mimo vkend</summary>
    ''' <param name="Day">slo dne v msci, kter vrtit</param>
    ''' <returns>Pokud je <paramref name="Day"/> 29, 30 nebo 31 a msc nem poadovan poet dn vrt den v nsledujcm msci</returns>
    ''' <exception cref="ArgumentException"><paramref name="Day"/> je 0 nebo vc jak 31</exception>
    Public Function DayInMonth(ByVal Day As Byte) As Date
        Return DayInMonth(Now, Day)
    End Function
End Module
