Imports System.ComponentModel, System.Windows.Forms
Namespace Login
    ''' <summary>Pihlaovac dialog</summary>
    <DefaultProperty("Text"), DefaultEvent("ButtonClick")> _
    Public Class LoginDialog : Inherits CommonDialog
        ''' <summary>Pihlaovac formul</summary>
        Private WithEvents LoginForm As New frmLogin
        ''' <summary>(Ped)vyplnn heslo</summary>
        <Browsable(False), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
        Public Property Password() As String
            Get
                Return LoginForm.Password
            End Get
            Set(ByVal value As String)
                LoginForm.Password = value
            End Set
        End Property
        ''' <summary>(Ped) vyplnn uivatelsk jmno</summary>
        <Browsable(False), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
        Public Property UserName() As String
            Get
                Return LoginForm.UserName
            End Get
            Set(ByVal value As String)
                LoginForm.UserName = value
            End Set
        End Property
        ''' <summary>Text v titulku pihlaovacho okna</summary>
        <DefaultValue("EOS login")> _
        <Description("Titulek pihlaovacho okna")> _
        Public Property Text() As String
            Get
                Return LoginForm.Text
            End Get
            Set(ByVal value As String)
                LoginForm.Text = value
            End Set
        End Property

        ''' <summary>When overridden in a derived class, resets the properties of a common dialog box to their default values.</summary>
        Public Overrides Sub Reset()
            Password = ""
            UserName = ""
        End Sub
        ''' <summary>When overridden in a derived class, specifies a common dialog box.</summary>
        ''' <param name="hwndOwner">A value that represents the window handle of the owner window for the common dialog box.</param>
        ''' <returns>true if the dialog box was successfully run; otherwise, false.</returns>
        Protected Overrides Function RunDialog(ByVal hwndOwner As System.IntPtr) As Boolean
            ShowDialog(Form.FromHandle(hwndOwner))
        End Function
        ''' <summary>Runs a common dialog box with the specified owner.</summary>
        ''' <param name="owner">Any object that implements System.Windows.Forms.IWin32Window that represents the top-level window that will own the modal dialog box.</param>
        ''' <returns>System.Windows.Forms.DialogResult.OK if the user clicks OK in the dialog box; otherwise, System.Windows.Forms.DialogResult.Cancel</returns>
        Public Shadows Function ShowDialog(Optional ByVal Owner As IWin32Window = Nothing) As DialogResult
            Return LoginForm.ShowDialog(Owner)
        End Function
        ''' <summary>Nastane pi kliknut na doplkov tlatko</summary>
        ''' <param name="sender">Zdroj udlosti</param>
        ''' <param name="e">Parametry</param>
        Public Event ButtonClick(ByVal sender As LoginDialog, ByVal e As LoginDialogEventArgs)

        ''' <summary>Nastane kdy uivatel klikne na tlatko OK piklaovacho formule a umouje ovit pihlaovac daje ped zavenm formule</summary>
        ''' <param name="sender">zdroj</param>
        ''' <param name="e">parametry</param>
        Public Event OKClick(ByVal sender As LoginDialog, ByVal e As FormCancelEventArgs)

        Private Sub LoginForm_BeforeOK(ByVal sender As frmLogin, ByVal e As System.ComponentModel.CancelEventArgs) Handles LoginForm.BeforeOK
            Dim Mye As New FormCancelEventArgs(sender)
            RaiseEvent OKClick(Me, Mye)
            e.Cancel = Mye.Cancel
        End Sub
        Private Sub LoginForm_ButtonClick(ByVal sender As frmLogin, ByVal e As System.EventArgs) Handles LoginForm.ButtonClick
            RaiseEvent ButtonClick(Me, New LoginDialogEventArgs(sender))
        End Sub
        ''' <summary>Paramatr udlosti <see cref="ButtonClick"/></summary>
        Public Class LoginDialogEventArgs : Inherits EventArgs
            ''' <summary>Udruje hodnotu vlastnosti <see cref="Form"/></summary>
            Private _Form As Form
            ''' <summary>CTor</summary>
            ''' <param name="Form">Pihlaovac formul</param>
           Public Sub New(ByVal Form As Form)
                _Form = Form
            End Sub
            ''' <summary>Pihlaovac formul</summary>
            Public ReadOnly Property Form() As Form
                Get
                    Return _Form
                End Get
            End Property
        End Class
        ''' <summary>Paramatr udlosti <see cref="ButtonClick"/></summary>
        Public Class FormCancelEventArgs : Inherits CancelEventArgs
            ''' <summary>Udruje hodnotu vlastnosti <see cref="Form"/></summary>
            Private _Form As Form
            ''' <summary>CTor</summary>
            ''' <param name="Form">Pihlaovac formul</param>
            Public Sub New(ByVal Form As Form)
                _Form = Form
            End Sub
            ''' <summary>Pihlaovac formul</summary>
            Public ReadOnly Property Form() As Form
                Get
                    Return _Form
                End Get
            End Property
        End Class
        ''' <summary>Stav doplujcho tlatka na formuli</summary>
        <Description("Stav doplujcho tlatka na formuli")> _
        <DefaultValue(GetType(LoginButtonState), "Hidden")> _
        Public Property AdditionalButton() As LoginButtonState
            Get
                Return LoginForm.Button
            End Get
            Set(ByVal value As LoginButtonState)
                LoginForm.Button = value
            End Set
        End Property
        ''' <summary>Text doplujcho tlatka formule</summary>
        <Description("Text doplujcho tlatka formule")> _
        <DefaultValue("&Monosti ...")> _
        Public Property AdditionalButtonText() As String
            Get
                Return LoginForm.ButtonText
            End Get
            Set(ByVal value As String)
                LoginForm.ButtonText = value
            End Set
        End Property
    End Class
End Namespace